#include "functions.h"

extern TIM_HandleTypeDef TimHandle;

void Init_Led(){
	 /* -1- Enable GPIOE Clock (to be able to program the configuration registers) */
	  __HAL_RCC_GPIOE_CLK_ENABLE();
	  GPIO_InitTypeDef  GPIO_LedStruct;

	  /* -2- Configure PE.8 to PE.15 IOs in output push-pull mode to drive external LEDs */
	  GPIO_LedStruct.Pin = (GPIO_PIN_15 |GPIO_PIN_14 |GPIO_PIN_13 |GPIO_PIN_12 |GPIO_PIN_11 | GPIO_PIN_10 | GPIO_PIN_9 | GPIO_PIN_8);
	  GPIO_LedStruct.Mode = GPIO_MODE_OUTPUT_PP;
	  GPIO_LedStruct.Pull = GPIO_PULLUP;
	  GPIO_LedStruct.Speed = GPIO_SPEED_FREQ_HIGH;

	  HAL_GPIO_Init(GPIOE, &GPIO_LedStruct);

}


void Init_TIM_IT(){

    /*Configure the TIM2 IRQ priority */
	HAL_NVIC_SetPriority(TIM2_IRQn, 0 ,0);

  	 /* Enable the TIM2 global Interrupt */
  	HAL_NVIC_EnableIRQ(TIM2_IRQn);

	__HAL_RCC_TIM2_CLK_ENABLE();

	TimHandle.Instance = TIM2;
	TimHandle.Init.Prescaler=18000-1;
	TimHandle.Init.CounterMode=TIM_COUNTERMODE_UP;
	TimHandle.Init.ClockDivision=TIM_CLOCKDIVISION_DIV1;
	TimHandle.Init.Period=OUR_PERIOD;

	HAL_TIM_Base_Init(&TimHandle);

	HAL_TIM_Base_Start_IT(&TimHandle);

}

void TIM2_IRQHandler(void)
{

  HAL_TIM_IRQHandler(&TimHandle);
}

void HAL_TIM_PeriodElapsedCallback(TIM_HandleTypeDef *htim)
{
	HAL_GPIO_TogglePin(GPIOE, GPIO_PIN_15);
	trace_printf("Into the Callback!!! \n");
}
